(*#load "types2.cmo"*)

open Types


let nbd= ref 0
let denv = Array.make_matrix largeur_max taille_max  ("$",C([],E(-1,-1)),E(-1,-1)) (* type (string * closure * env) array *)
let countd=Array.make largeur_max 0

let rec print_env2 = function
  | E(i,-1) -> print_string "∅"
  | E(i,n)-> let (s,C(bag,E(xc,yc)),E(xn,yn))= (denv.(i).(n)) in   
      print_string ("D("^string_of_int(i)^","^string_of_int(n)^"):["^s^"->("); print_bag bag; print_string ","; print_env2 (E(i,yc)); print_string ")]·";print_env2 (E(i,yn))


let mise_en_forme expr stack env = List.rev (C([expr,-42],env)::stack);;

let rec concat = function
  | [] -> []
  |a::b -> a@(concat b);;

let copy_env2 i j = (* duplique E(i,_) dans E(j,_) *)
  countd.(j)<- countd.(i);
  for k=0 to countd.(j) do
    pointeurs.(j).(k)<-pointeurs.(i).(k); (* dédouble les pointeurs *)
    let a,C(b,E(x1,y1)),E(x2,y2) = denv.(i).(k) in
      denv.(j).(k) <- a,C(b,E(j,y1)),E(j,y2)
  done


let open_mu s bag envc next_env n k=
  let E(xc,yc) = envc and E(xn,yn)=next_env in 
  let rec split l1 (expr,mult) l2 =
    (match l2 with
    |[] ->  (
(*	print_string "Access:  "; print_expr expr; print_string ("   env n°: "^(soi (xc))^"\n");	*)
	match expr,mult with
      | expr,mult when mult =infinity -> [expr,xc]
      | expr,mult when mult =1 -> denv.(n).(k)<-(s,C(l1,envc),next_env) ; [expr,xc]
      | expr,mult -> denv.(n).(k)<-(s,C((expr,mult-1)::l1,envc),next_env); [expr,xc])		    
    |a::b -> nbd:= !nbd+1;
	let ahah= !nbd in
	copy_env2 n (!nbd);
(*	print_string "Access:  "; print_expr expr; print_string ("   env n°: "^(soi (!nbd))^"\n");	*)
	(match expr,mult with
	| expr,mult when mult =infinity -> (expr,!nbd)::(split (l1@[expr,mult]) a b)
	| expr,mult when mult =1 -> denv.(!nbd).(k)<-(s,C(l1@l2,E(!nbd,yc)),E(!nbd,yn));
	    (expr,ahah)::(split (l1@[expr,mult]) a b)
	| expr,mult -> denv.(!nbd).(k)<-(s,C(l1@((expr,mult-1)::l2),E(!nbd,yc)),E(!nbd,yn));
	    (expr,ahah)::(split (l1@[expr,mult]) a b))
    )
  in split [] (head(bag)) (tail(bag));;
    
  
let rec mu = function 
  |Zero, E(n,k) -> [Zero, n]
  |Cons x, E(n,k) -> [Var x,n]
  |Var x, E(n,k) -> (try (let (v,C(bag,envc),next_env)=denv.(n).(k) in
    if v=x
    then
      (match bag with
      |[] -> [Zero, n]
      |[Cons x,i]-> [Var x, n]
      | _ -> let bag_open=open_mu x bag envc next_env n k in 
(*	List.iter (fun (expr,env) -> print_expr expr; print_string "  dans  "; print_env2 (E(env,k));print_newline()) bag_open;*)
	let E(xc,yc)=envc in
	concat (List.map (fun (expr,env) ->  mu (expr,E(env,yc))) bag_open)) 
    else 
      mu (Var x, next_env))
  with _ -> print_string ((soi n)^"   "^(soi k)^"\n");failwith "aoiun")
	(* match environnement, puis access_nd en gros*)
	
  |Abs(x,t), E(n,k) -> countd.(n)<-countd.(n)+1;
      denv.(n).(countd.(n))<-(x,C([Cons x,infinity],E(n,k)),E(n,k));
      List.map (fun (expr,blop) -> Abs(x,expr),blop) (mu (t,E(n,countd.(n))))
  |App(t,bigb), E(n,k) -> let openbag = mu_aux (bigb,E(n,k)) in 
    concat (List.map (fun (bag,env) -> let liste = mu (t,E(env,k)) in
    List.map (fun (expr,bli) -> App(expr,bag),bli) liste) openbag)
      
and mu_aux = function
  |[],E(n,k) -> [[],n]
  |[b,m],E(n,k) when m=infinity-> 
      let openb = mub (b,E(n,k)) in
      concat (List.map (fun (bli,env) ->(* print_string "mu_aux : "; print_bag bli; print_string ("  dans  "); print_env2 (E(env,k)); print_newline();*)
	let liste = [[],env] in
      List.map (fun (lis,envi) -> bli@lis,envi) liste) openb)   
  |((b,m)::bag),E(n,k) when m=infinity-> 
      let openb = mub (b,E(n,k)) in
      concat (List.map (fun (bli,env) -> 
	let liste = mu_aux (bag,E(env,k)) in
      List.map (fun (lis,envi) -> bli@lis,envi) liste) openb)   
  |((b,m)::bag),E(n,k) -> let openb = mu (b,E(n,k)) in
    concat (List.map (fun (expr,env) ->
      if m=1 then  
	let liste = mu_aux(bag,E(env,k)) in
	List.map (fun (lis,envi) -> ((expr,1)::lis),envi) liste  
      else let liste = mu_aux((b,m-1)::bag,E(env,k)) in
      List.map (fun (lis,envi) -> ((expr,1)::lis),envi) liste) openb) 

and mub_aux = function 
  |[],E(n,k) -> [[Zero,1],n]
  |[b,m],E(n,k) -> 
      let openb = mub (b,E(n,k)) in
      concat (List.map (fun (bli,env) -> let liste = [[],n] in
      List.map (fun (lis,envi) -> bli@lis,envi) liste) openb)   
  |((b,m)::bag),E(n,k) -> 
      let openb = mub (b,E(n,k)) in
      concat (List.map (fun (bli,env) -> let liste = mub_aux (bag,E(env,k)) in
      List.map (fun (lis,envi) -> bli@lis,envi) liste) openb)   

and open_mub = function (* Pas bon du tout *)
  |[],E(n,k) -> [[Zero,1],n] (* ou pas, à voir *)
  |[b,m],E(n,k) -> mub (b,E(n,k)) 
(*  |[b,m],E(n,k) -> nbd:=nbd+1;
      let ahah = !nbd in
      copy_env2 n ahah; (* il va falloir zipper... *)
      
      let openb = mu (b,E(n,k)) in 
             ([Zero,1],n)::
	     (concat (List.map (fun (expr,env) -> let liste = [[],n] in
	      List.map (fun (lis,envi) -> (expr,1)::lis,envi) liste) openb))
*)
  |((b,m)::bag),E(n,k) -> 
      let openb = mub (b,E(n,k)) in
      concat (List.map (fun (bli,env) -> let liste = open_mub (bag,E(env,k)) in
      List.map (fun (lis,envi) -> bli@lis,envi) liste) openb)
(*  |((b,m)::bag),E(n,k) -> 
      let openb = mu (b,E(n,k)) in 
             (open_mub (bag,E(n,k))@
	     (concat (List.map (fun (expr,env) -> let liste = open_mub (bag,E(env,k)) in
	      List.map (fun (lis,envi) -> (expr,1)::lis,envi) liste) openb)))*)
		
and mub = function
  |Zero, E(n,k) -> [[], n]
  |Cons x,E(n,k) -> [[Var x,infinity],n]
  |Var x, E(n,k) -> let (v,C(bag,envc),next_env)=denv.(n).(k) in
    if v=x
    then 
      (match bag with
      |[] -> [[], n] 
      |[Cons x,i]-> [[Var x,infinity], n] 
      |_ -> let E(xc,yc) = envc and E(xn,yn)=next_env in 
	let rec split l1 l2 =  (* zipper again *)
	  match l2 with
	  |[] -> l1
	  | (a,m)::b when m=infinity -> 
	      let plop=concat(List.map (fun (blop,envi,devant)->  let opena= mub(a,E(envi,yc)) in
	      List.map (fun (bag,env2) -> blop@bag,env2,devant@[a,m]) opena) l1) in
	      split plop b 
	  | (a,m)::b when m=1-> 
	      let plop = concat (List.map (fun (blop,envi,devant)->
		nbd:=!nbd+1;
		copy_env2 envi (!nbd);
		denv.(!nbd).(k)<-(v,C(devant@b,E(!nbd,yc)),E(!nbd,yn));
		let opena=mu (a,E(!nbd,yc)) in
		List.map (fun (termes,enva) -> (blop,envi,devant@[a,1])::[(termes,1)::blop,enva,devant]) opena) l1) in
	      split (concat plop) b
	  | (a,m)::b -> split l1 ((a,m-1)::(a,1)::b)
	in 
	let clean l = List.map (fun (x,y,z)->x,y) l
	in clean (split [[],n,[]] bag)
		    
      )
	
    else 
      mub (Var x, next_env)   
	
  |App(t,bigb), E(n,k) -> let openbag = mub_aux (bigb,E(n,k)) in 
    concat (List.map (fun (bag,env) -> let liste = mub (t,E(env,k)) in
    List.map (fun (termes,bli) -> 
      (List.map (fun (expr,mult) -> App(expr,bag),mult) termes),bli) liste) openbag)
      
  |Abs(x,t), E(n,k) -> countd.(n)<-countd.(n)+1;
      denv.(n).(countd.(n))<-(x,C([Cons x,infinity],E(n,k)),E(n,k));
      List.map (fun (lis,blop) -> 
	(List.map (fun (expr,mult)-> Abs(x,expr),mult) lis,blop)) (mub (t,E(n,countd.(n))));;
	




let has_linear (E(n,k))= 
  let _,C(bag,_),_ = denv.(n).(k) in
  count_linear bag > 0;;
    
let est_vide n = 
  let alors=ref false in
  for i = 0 to countd.(n) do
    alors:= !alors || (has_linear (E(n,i)))
  done;
  !alors;;
  

let decompilation head expr env stack = 
  for i=0 to largeur_max-1 do
      for j=0 to taille_max-1 do
	denv.(i).(j)<-genv.(i).(j)
      done;
    countd.(i)<-count_env.(i)
  done;
  nbd:= !nb_env;
  let rec aux expr (E(n,k))=function
    |[] -> mu (expr,E(n,k))
    |[C(blop,envc)] -> let E(nc,kc)=envc in
      let liste=mu_aux (blop,E(n,kc)) in
      concat (List.map (fun (bag,envi) -> let termes = mu(expr,E(envi,k)) in
      List.map (fun (ter,eee) -> App(ter,bag),eee) termes) liste)
    |C(blop,env)::stack -> let E(n,k)=env in
      let liste=mu_aux (blop, env) in
      concat (List.map (fun (bag,envi) -> let termes = aux expr (E(envi,k)) stack in
      List.map (fun (ter,eee) -> App(ter,bag),eee) termes) liste)
  in let pre_res=aux expr env (List.rev stack) in
  let rec put_head expr = function
    |[] -> expr
    |t::q -> put_head (Abs(t,expr)) q in
  List.map (fun (expr,n) ->   if (est_vide n) then Zero  else put_head expr head) pre_res;;

