#load "types.cmo"
#load "decompilation.cmo"

open Types
open Decompilation


let trace = true

let print tab hd (instr,expr,stack,env)= 
  if trace 
  then (print_compile tab hd (instr,expr,stack,env);
	print_string "Terme décompilé :  ";
	print_somme (decompilation hd expr env stack);
	print_newline())

  else ()

(* Les exceptions *)

exception Starvation 
exception Undefined
exception Overflow
exception Blop
exception End_under_lambda


(* La recherche d'une variable dans son environnement *)
let rec filtre branche=function
  |[]->[]
  |C(bag,E(n,k))::stack -> C(bag,E(branche,k))::(filtre branche stack)

let rec access_nd v stack= function 
  | E(_,-1) -> raise Undefined
  | E(n,k) ->( (*print_string ("access "^v^" in E("^string_of_int(n)^")\n");*)
      let (s,C(bag,envc),next_env)= (genv.(n).(k)) in
      try (if v=s
      then
	(
	 (* Ouverture de la liste façon Zipper  *)
	 let E(xc,yc) = envc and E(xn,yn)=next_env in 
	 let rec split l1 (expr,mult) l2 =
	   (match l2 with
	   |[] ->  (
(*	       print_string "Access:  "; print_expr expr; print_string ("   env n°: "^(soi (xc))^"\n");*)
	       match expr,mult with
	     | expr,mult when mult =infinity -> [expr,stack,envc]
	     | expr,mult when mult =1 -> genv.(n).(k)<-(s,C(l1,envc),next_env) ; [expr,stack,envc]
	     | expr,mult -> split l1 (expr,mult-1) [expr,1])
                            (*genv.(n).(k)<-(s,C((expr,mult-1)::l1,envc),next_env); [expr,stack,envc])*)
	   |a::b -> nb_env:=!nb_env+1;
	       let ahah = !nb_env in
(*	       print_string "Access:  "; print_expr expr; print_string ("   env n°: "^(soi (!nb_env))^"\n");*)
	       copy_env n (!nb_env);
	       (match expr,mult with
	       | expr,mult when mult =infinity -> (expr,filtre ahah stack,E(ahah,yc))::(split (l1@[expr,mult]) a b)
	       | expr,mult when mult =1 -> genv.(!nb_env).(k)<-(s,C(l1@l2,E(ahah,yc)),E(ahah,yn));
		   (expr,filtre ahah stack,E(ahah,yc))::(split (l1@[expr,mult]) a b)
	       | expr,mult -> split l1 (expr,mult-1) ((expr,1)::l2))
                   (*genv.(!nb_env).(k)<-(s,C(l1@((expr,mult-1)::l2),E(ahah,yc)),E(ahah,yn));
		   (expr,filtre ahah stack,E(ahah,yc))::(split (l1@[expr,mult]) a b))*)
	   )
	 in split [] (head(bag)) (tail(bag)))
      else 
	( access_nd v stack next_env) )
      with Empty_bag -> (if trace then print_string ("Trying to access "^v^" in E("^string_of_int(n)^","^string_of_int(k)^")\n"); raise Starvation)
     )
	
	
let print_result res= 
  let rec aux1 = function
    |[]-> print_expr Zero
    |[a,E(i,j)]-> print_expr a; print_string "  dans  "; print_env_final (E(i,j)); print_string "  | Global: "; 
	print_env_total i; print_newline(); print_string "Decompilation : "; 
	print_somme  (decompilation [] a (E(i,j)) [])
    |(a,E(i,j))::b -> print_expr a; 
	print_string "  dans  "; print_env_final (E(i,j)); 
	print_string "  | Global: "; print_env_total i; 
	print_newline(); print_string "Decompilation : "; 
	print_somme (decompilation [] a (E(i,j)) []);
	print_string "\n +\n "; aux1 b
  and  aux2 = function
    |[]-> print_expr Zero
    |[a,E(i,j)]->  print_env_total i; print_newline(); print_string "Decompilation : "; 
	head (List.map (fun expr -> print_expr expr; print_string " + ") (decompilation [] a (E(i,j)) []))
    |(a,E(i,j))::b -> print_somme (decompilation [] a (E(i,j)) []);
	print_string "\n +\n "; aux1 b
  in
  let rec put_head = function
    |[] -> []
    |([],a,b)::suite->(a,b)::(put_head suite)
    |(t::q,expr,env)::suite->put_head((q,Abs(t,expr),env)::suite)
  in
    print_string ("\n***************************  RESULT **************************************\n");
  if trace then aux1 (put_head res) else aux2 (put_head res);
  print_string("\n**************************************************************************\n")
    
    
let rec reconstruct expr = function
  |[] -> expr
  |(C(b,env))::stack -> reconstruct (App(expr,b)) stack
	
	
	
	
let compile_nd blop= 
  clean();
  nb_env:=0;
  let result=ref [] in
  let rec nd_aux tab tete l =
    let compile tab tete expr stack env = 
      print tab tete (Access("begin"),expr,stack,env);
      let rec compile_aux tab hd expr stack env =
	let E(n,k)=env in
	if (n>=0 && count_env.(n) > max_loop) then raise Overflow (* moué *)
	else (
	  match expr with
	  | Zero -> (* count_env.(n)<-0; *) print tab hd (Access("fin"),Zero,stack,env)
	  | Cons x -> result:= (hd,(reconstruct (Cons(x)) stack),env) :: (!result);  (* cacccccaaaa ça..... *)
	      print tab hd (Access("fin"), Cons x,stack,env); raise End_under_lambda
	  | Var v   -> (try (let l=access_nd v stack env in  
	    let rec print_access = function
	      |[] -> () 
	      |(li,st,E(j,k))::tl-> print tab hd (Access(v),li,st,E(j,k)); 
		  print_access tl 
	    in print_access l;
	    (match l with
	    |[] -> failwith "Tiens c'est bizarre"
	    |[li,st,E(j,k)]-> compile_aux tab hd li st (E(n,k))
	    | _ -> (if trace then (print_tab tab; print_string "***  Plusieurs branches *** \n");
		    (nd_aux (tab+1) hd l))))
	  with 
	    | Starvation ->  print tab hd (Access("fin"),Zero,stack,env);
		(* count_env.(n)<-0*)
	    | Undefined ->  
		if trace then (print_tab tab; print_string ("***  "^v^" is not in the environnement ***\n")); 
		print tab hd  (Access(v),Var v,stack,env);
		result:=(hd,Var v,env)::(!result);
		
		print tab hd (Access "fin",Var v,stack,env)
	    | Overfed(var) -> print_string "zut, ça ne devait plus arriver"; (*if trace then print_string ("***  Overfed in "^var^" ***\n");
									       (*			      print_ref();*)
									       (* count_env.(n)<-0*);*)
		print tab hd (Access "fin",Zero,stack,env))
		
	  | App(f,b)  -> parcours_env add_ref env;
	      print tab hd (Push(b),f,C(b,env)::stack,env); 
	      compile_aux tab hd f (C(b,env)::stack) env 
		
	  | Abs (v,e) -> (match stack with
			    | [] -> count_env.(n)<-count_env.(n)+1; (* mauvaise méthode... va falloir mettre une liste des lambda de tête... *)
				genv.(n).(count_env.(n))<-(v,C([Cons v,infinity],env),env); (* ATTENTION *)
				print tab (v::hd) (Go_under(v),e,stack,E(n,count_env.(n)));
				(try (compile_aux tab (v::hd) e stack (E(n,count_env.(n))))
				 with End_under_lambda -> 
				   (*(match !result with
				     |[] -> failwith "souci"
				     |(terme,E(n,k))::suite -> (result:= (Abs(v,terme),env)::suite);
				     print_string ("Retour under_lambda   "^v^"  :"); print_expr terme; print_newline();*)
				   raise End_under_lambda)
				  
			    | (C(b,eee))::t -> if ( (occurences (Abs(v,e))<>infinity) && occurences (Abs(v,e)) < count_linear b && true)
			      then (if trace then print_string "*** Overfed ! *** Result: 0 ***\n")
			      else (
				count_env.(n)<-count_env.(n)+1;
				(*   PATCH: on va directement chercher le "bout" du pointeur (application ou abstraction ou bag multiple) *)
				genv.(n).(count_env.(n))<-(v,C(b,eee),env); (* ATTENTION *)
				(*parcours_env add_ref eee;*)
				print tab hd (Grab(v),e,t,E(n,count_env.(n)));
				compile_aux tab hd e t (E(n,count_env.(n)))
			      )))
	  
      in (*try  *) compile_aux tab tete expr stack env 
	(* with End_under_lambda ->  let (terme,E(n,k)) = head(!result) in 
	   print_string ("Retour moche under_lambda  :"); print_expr terme; print_newline();() *)
    in (match l with
    |[]->() 
    |[expr,stack,env] -> (try (compile tab tete expr stack env) with End_under_lambda -> ())
    |(expr,stack,env)::t -> try (compile tab tete expr stack env; 
				 if trace then print_string "\n\n\t ****  +  ****\n\n";
				 nd_aux tab tete t)
    with _ -> (if trace then print_string "\n\n\t ****  +  ****\n\n";
	       nd_aux tab tete t)
       )
  in nd_aux 0 [] [blop]; print_result (!result)
    
let rec exec = function
  |[]->()
  |[a]-> 
     if not(trace)
     then print_expr a;
      compile_nd (a,[],empty);
  |a::b-> 
     if not(trace)
     then print_expr a;
      compile_nd (a,[],empty);
      print_string "\n\n***** NEXT *****\n\n";
      exec b
	



(********************************************************************************************************)
(*********************                   EXEMPLES                   *************************************)
(********************************************************************************************************)

let term n = 
  let rec aux = function
    | 0 -> Var("z")
    | n -> App(Var("s"),[aux (n-1),1])
  in
    Abs("s",Abs("z",aux n))

let i=infinity
let id s = Abs(s,Var s)
let delta = Abs("x",App(Var("x"),[Var("x"),i])) 
let _=occurences delta;;

let omega = App(delta,[delta,1]);;



let ex4=App(Abs("y",App(Var "y",[Var "y",i])),[id "s",1; id "w",i]);;
print_expr ex4;;
exec[ex4];;




exec [App(delta,[ id "w",2; id "u",i])];; 
exec [App(Abs("x",Abs("y",App(Var "x",[Var "x",i]))),[id "s",i;id "w", 1])];;

let ex1 =App(App(Abs("f",Abs("x",App(Var("f"),[App(Var "f",[Var("x"),1]),1]))),[Abs("u",Var "u"),1;Abs("x",Var("x")),i]),[Abs("y",Var("y")),1]);; 
print_expr ex1;;
exec [ex1];;

let ex10 =App(App(Abs("f",Abs("x",App(Var("f"),[App(Var "f",[Var("x"),1]),1]))),[Abs("u",Var "u"),1;Abs("x",Var("x")),i]),[Abs("y",Var("y")),1]);; 
let ex2=App(Abs("x",App(Var("x"),[Var("x"),infinity])),[Abs("x",App(Var("x"),[Var("x"),infinity])),6]);; 
let ex3=App(App(Abs("x",Abs("y",App(App(App(Var("x"),[Var("x"),1]),[Abs("y",App(Var("x"),[Var("y"),1])),1]),[Var("y"),1]))),[Abs("x",Var("x")),2]),[Abs("t",Var("t")),1]);;
let ex4=App(Abs("t",App(Abs("x",App(id "y",[Var "x",i;Var "t",i])),[id "t",i])),[id "w",1]);;
let ex4=App(Abs("x",App(Abs("y",App(Var "y",[Var "y",i])),[Var "x",i])),[id "s",1; id "w",i]);;
occurences (Abs("f",Abs("x",App(Var("f"),[Var("x"),1]))));;
occurences (Abs("x",Abs("y",App(App(App(Var("x"),[Var("x"),1]),[Abs("x",App(Var("x"),[Var("y"),1])),1]),[Var("y"),1]))));;


let test = App(Abs("x",App(Abs("y",App(Abs("u",Var "u"),[Var "y",1])),[Var "x",1])),[Abs("c",Var"c"),2]) in 
  print_expr test;
  exec [test];;





exec [App(Abs("w",App(delta,[Var "w",i])),[Abs("u",Var"u"),1;Abs("y",Var "y"),i])];;
exec [App(Abs("x",App(delta,[Var "x",i])),[Abs("u",Var"u"),i;Abs("y",Var "y"),1])];;



let bug=  App(Abs("x",App(Var("x"),[Var("x"),2])),[delta,i]);;
let b= App(Abs("x",App(delta,[Var "x",i])),[id "u",1])
in exec [bug;b];;

